// written by Zheng Gengbin
//

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
#endif

#include "compilerApi.h"

#include "anls_att.h"


proc_reference::proc_reference(void)
{
	number=0;
	for (int i=0; i < MAX_PROC_DIM ; i++ )
	{
		actuals[i]=NULL;
		dummys[i]=NULL;
	}
}

int proc_reference::get_number(void)
{
	return number;
}

void proc_reference::add_pair(SgExpression * actu , SgSymbol * dum )
{
	if ( number >= MAX_PROC_DIM )
	{
		printf("Two many dummies !\n");
		exit(1);
	}
	actuals[number] = actu ;
	dummys[number] = dum;
	number ++;
}

void proc_reference::setHeader(SgFunctionSymb *hedr, SgFunctionSymb *rhedr)
{
	header = hedr;
	real_header = rhedr;
}

SgFunctionSymb *proc_reference::getHeader(void)
{
	return header ;
}

SgFunctionSymb *proc_reference::getRealHeader(void)
{
	return real_header ;
}

SgSymbol *proc_reference::get_dummy(int i)
{
	return dummys[i];
}

SgExpression *proc_reference::get_actual(int i)
{
	return actuals[i];
}



